/*
	elementals.js (c) Jason M. Knight
	Version 3.0 BETA 1, 19 March 2017
*/

var
	_;

(function(w, d) {

	"use strict";

	function browserFix(e, n, t) {
		if (e[n]) return true;
		t || (t = n.charAt(0).toUpperCase() + n.substr(1));
		for (var i = 0, j, k; j = _.browserPrefixes[i]; i++)
			if (e[k = j + t]) return e[n] = e[k], true;
		return false;
	}

	function buttonSelect(e) {
		_.Select.node(e.currentTarget[d_sel]);
	}

	function newAX(a) {
		try { return new activeXObject(a); } catch (e) { return false; }
	}

	function ptAdd(e, p) {
		for (var i in p) e.prototype[i] || (e.prototype[i] = p[i]);
	}

	function eXMLHttp(h, x) {

		if (!(x = this.result = w.XMLHttpRequest ? new XMLHttpRequest() : (
			newAX('Msxml2.XMLHTTP.6.0') ||
			newAX('Msxml2.XMLHTTP.3.0') ||
			newAX('Microsoft.XMLHTTP')
		))) throw new Error('Unable to create XMLHttpRequest or ActiveX ' + mx);

		if (h.progress) x.onprogress = h.progress;

		x.getJSON = function() {
			return JSON.parse(this.responseText);
		};

		x.getXMLValueById = function(i) {
			return (i = this.responseXML.getElementById(i)) ? _.Node.text(i) : null;
		};

		x.getXMLValuesByTagName = function(t, l, e) {
			if (!(e = this.responseXML.getElementsByTagName(t))) return false;
			if (l === true) return _.Node.text(e[0]);
			if (!l || e.length < l) l = e.length;
			for (var r = [], i = 0; i < l; i++) r.push(_.Node.text(e[i]));
			return r;
		};

		x.onreadystatechange  = function() {
			if (h.state && h.state[x.readyState]) return h.state[x.readyState](x, h);
			if (4 == x.readyState) {
				if (h.status) {
					if (h.status[x.status]) return h.status[x.status](x, h);
					if (h.status.catchAll) return h.status.catchAll(x, h);
				}
				_.log[h.onStatusLog || 'none']('Unhandled AJAX Status ' + x.status);
			} else _.log[h.onReadyLog || 'warn'].('Unhandled AJAX readyState ' + x.readyState, h.onReadyLog);
		};

		if (h.request) {
			x.open(h.request[0], h.request[1]);
			if (h.mimeType) x.overrideMimeType(h.mimeType);
			if (h.headers) for (var i in h.headers)
				x.setRequestHeader(i, h.headers[i]);
			x.send(h.request[2]);
		}

	}

	function nCountBy(e, m, n, c) {
		c = 0;
		_.Node[n](e, function() { return c++ }, m);
		return c;
	}

	function escFunc(m) {
		return escMap[m] || '\\u' + (m.charCodeAt(0) + 65536).toString(16).substr(1);
	}

	function jsWarn(m) {
		_.log.warn('This browser does not support JavaScript ' + m);
		return false;
	}

	function originalSort(a, b) {
		return _.Compare.numeric(
			a.tag.getAttribute(d_op),
			b.tag.getAttribute(d_op)
		);
	}

	function uSortOp(e) {
		e.getAttribute(d_op) || e.setAttribute(d_op, tList1.length);
	}

	function uSortTBODYe(e) {
		return tList2.push(_.Node.text(e)), true;
	}

	function uSortTBODYRow(e) {
		uSortOp(e);
		tList2 = [];
		_.Node.eachChild(e, uSortTBODYe);
		tList1.push({ tag : e.cloneNode(true), data : tList2 });
		return tList2 = [], true;
	}

	function uSortLi(e) {
		uSortOp(e);
		tList1.push({ tag : e.cloneNode(true), data : _.Node.text(e) });
		return true;
	}

	var
		escMap = {
			'"' : '\\"', '\\' : '\\\\', '\b' : '\\b', '\f' : '\\f',
			'\n' : '\\n', '\r' : '\\r', '\t' : '\\t'
		},
		escRegex = /[\\\u0000-\u001F\u0022\u2028\u2029]/g,
		stripCamelRegex = /([A-Z])/g,
		toCamelRegex = /(\W[\w])/g,
		trimRegex = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,

		d_op = 'data-uSortOriginalPlace',
		d_sel = 'data-eNodeSelectTarget',
		d_sort = 'data-uSortElementSorted',
		raf = 'requestAnimationFrame',
		caf = 'cancelAnimationFrame',

		tList1 = [],
		tList2 = [],
		lastAnimTime = 0,

	_ = {

		ajax : function(h) {
			switch (typeof h) {
				case 'object': break;
				case 'function':
					h = { 'status' : { '200' : h } };
					break;
				default:
					throw new Error(
						'Invalid Ajax declaration, parameter "handler" not a function or object!'
					);
			}
			return (new eXMLHttp(h)).result;
		},

		browserPrefixes : ['ms','moz','webkit','moz'],
		
		Class : {

			add : function(e, n) {
				if (n instanceof Array) return n.callbackOr(e, _.Class.add);
				return _.Class.exists(e, n) || (e.className += (e.className ? ' ' : '') + n);
			},

			exists : function(e, n) {
				if (n instanceof Array) return n.callbackAnd(e, _.Class.exists);
				return RegExp('(\\s|^)' + n + '(\\s|$)').test(e.className);
			},

			remove : function(e, n) {
				if (n instanceof Array) return n.callbackOr(e, _.Class.remove);
				if (!_.Class.exists(e, n)) return false;
				e.className = e.className.replace(
					new RegExp("(\\s|^)" + n + "(\\s|$)")," "
				).trim();
				return true;
			},

			swap : function(e, o, n) {
				o = _.Class.remove(e, o);
				n = _.Class.add(e, n);
				return o || n;
			},

			toggle : function(e, n) {
				if (_.Class.remove(e, n)) return false;
				_.Class.add(e,n);
				return true;
			}

		}, // _.className

		Compare : {

			string : function(a, b) {
				return _.stringNormalize(a).localeCompare(
					_.stringNormalize(b)
				);
			},

			stringI : function(a, b) {
				return _.stringNormalize(a, true).localeCompare(
					_.stringNormalize(b, true)
				);
			},

			numeric : function(a, b) {
				return (Number(a) || 0) - (Number(b) || 0);
			}

		}, // _.Compare

		Cookies : {

			remove : function(n, p, o) {
				if (_.Cookies.get(n)) _.cookie.set(n, '', 0, p, o);
			},

			get : function(n) {
				return n && (d.cookie.match(
					new RegExp('(^|;)\\s*' + n + '\\s*=\\s*([^;]*)')
				) ? unescape(name[2]) : false);
			},

			set : function(n, v, t, p, o, s, cd) {
				if (typeof t == 'undefined') t = 34160760000000;
				if (isInteger(t)) t = new Date(t);
				if (t instanceof Date) t = t.toGMTString();
				_.Throw.nonType(t, 'string');
				d.cookie = n + '=' + escape(v) + '; expires=' + t +
					(p ? '; path=' + p : '') +
					(o ? '; domain=' + o : '') +
					(s ? '; secure' : '');
			},

			setAfter : function(n, v, t, p, o, s) {
				_.Cookies.set(n, v, new Date().getTime() + t, p, o, s);
			}

		}, // _.Cookies

		Data : {

			get : function(e, n, s, r) {
				return (r = e.getAttribute(n = 'data-' + n)) === null ? false :
					r === '' ? e.hasAttribute && e.hasAttribute(n) :
						s ? r.split(',') : r;
			}

		}, // _.Data

		emptyTags : [
			'AREA', 'BASE', 'BR', 'COL', 'COMMAND', 'EMBED', 'HR', 'IMG',
			'INPUT', 'KEYGEN', 'LINK', 'META', 'PARAM', 'SOURCE', 'TRACK',
			'WBR'
		],
		
		Event : {

			add : function(e, v, c) { e.addEventListener(v, c, false); },

			prevent : function(e) {
				// this MAY be overkill... Oh, who are we kidding, it is!
				e.cancelBubble = true;
				if (e.stopPropagation) e.stopPropagation();
				if (e.preventDefault) e.preventDefault();
				e.returnValue = false;
			}

		}, // _.Event

		Form : {

			serialize : function(form) {
				// to-do throw if form is not <form>
				function add(n, v) {
					if (v && (v != '')) r +=
						(r ? '&' : '') +
						encodeURIComponent(n) +
						'=' +
						encodeURIComponent(v);
				}
				for (var i = 0, r = '', e, o; e = form.elements[i]; i++) {
					if (e.name) switch (e.tagName) {
						case 'INPUT':
							switch (e.type) {
								case 'file' :
									// to-do, add serialization for browsers that support it
									throw new TypeError('Cannot Serialize a <input type="file">');
								case 'checkbox':
								case 'radio':
									if (!e.checked) continue;
							}
						case 'BUTTON':
						case 'TEXTAREA':
							add(e.name, e.value);
						break;
						case 'SELECT':
							o = e.options[e.selectedIndex];
							add(e.name, o.value || _.Node.text(o));
					}
				}
				return r;
			}

		}, // _.Form

		log : {
		
			alert : function(m) { alert(m) },

			append : function(m) {
				_.make('br', { last : d.body });
				_.Node.add(d.body, m);
			},

			error : function(m) { throw new Error(m); },

			log : function(m) { if (w.console) console.log(m); else this.append(m); },
			
			none : function() {},

			warn : function(m) { if (w.console) console.warn(m); else this.append(m); }
			
		},

		make : function(s, a, e) {
			s = s.splitSelector();
			e = d.createElement(s.tag);
			s.classes && (e.className = s.classes);
			s.id && (e.id = s.id);
			if (a) for (var i in a) {
				if (i.substr(0, 2) == 'on') _.Event.add(e, i.substr(2), a[i]);
				else switch (i) {
					case 'after':
					case 'before':
					case 'first':
					case 'last':
					case 'replace':
						_.Node.add(a[i], e, i);
						break;
					case 'content':
						_.Node.add(e, a[i], i);
						break;
					case 'style':
						for (var j in a[i]) e.style[j] = a.style[j];
						break;
					case 'type':
						// legacy IE can't handle setting type on Element directly
						e.setAttribute('type', a[i]);
						break;
					default:
						e[i] = a[i];
				}
			}
			return e;
		}, // _.make

		Node : {

			add : function(e, c, p) {
				if (p) p = p.toLowerCase();
				if ('object' != typeof c) c = d.createTextNode(c);
				switch (p) {
					case 'first' : return e.insertBefore(c, e.firstChild);
					case 'before': return e.parentNode.insertBefore(c, e);
					case 'after' : return e.parentNode.insertBefore(c, e.nextSibling);
					case 'replace' : return _.Node.replace(e, c);
					case 'content' : return _.Node.content(e, c);
				}
				return e.appendChild(c);
			},

			addSelectButton : function(e, t, n, p, b) {
				b = _.make('button.selectContents', {
					content : t || 'select',
					onclick : buttonSelect
				});
				b[d_sel] = e;
				_.Node.add(n || e, b, p || 'before');
			},

			content : function(e, n) {
				_.Node.flush(e);
				_.Node.add(e, n);
				return n;
			},

			countAll : function(e, m) {
				return nCountBy(e, m, 'eachAll');
			},

			countChildren : function(e, m) {
				return nCountBy(e, m, 'eachChild');
			},

			eachAll : function(e, c, m, z) {
				if (z = e.firstChild) do {
					if (
						(_.Node.mask(z, m) && (c(z) === false)) ||
						(z.firstChild && (_.Node.eachAll(z, c, m) === false))
					) return false;
				} while (z = z.nextSibling);
				return true;
			},

			eachChild : function(e, c, m, z) {
				if (z = e.firstChild) do {
					if (_.Node.mask(z, m) && (c(z) === false)) return false;
				} while (z = z.nextSibling);
				return true;
			},

			first : function(e, m) {
				return _.Node.walk(e, m, 'firstChild', 'nextSibling');
			},

			flush : function(e) {
				while (e.firstChild) e.removeChild(e.firstChild);
			},

			last : function(e, m) {
				return _.Node.walk(e, m, 'lastChild', 'previousSibling');
			},

			mask : function(e, m) {
				if (isNaN(m = m || 1)) return (e.nodeType == 1) && (e.tagName == m.toUpperCase());
				return (1 << (e.nodeType == 0 ? 1 : e.nodeType - 1)) & (m > 0);
			},

			MASKS : {
				ELEMENT    : 1,
				TEXT       : 4,
				PROCESSING : 64,
				COMMENT    : 128,
				DOCUMENT   : 256,
				DOCTYPE    : 512,
				FRAGMENT   : 1024
			},

			next : function(e, m) {
				return _.Node.walk(e, m, 'nextSibling', 'nextSibling');
			},

			nextRemove : function(e, m, n) {
				n = _.Node.next(e, m);
				_.Node.remove(e);
				return n;
			},

			prev : function(e, m) {
				return _.Node.walk(e, m, 'previousSibling', 'previousSibling');
			},

			prevRemove : function(e, m, n) {
				n = _.Node.prev(e, m);
				_.Node.remove(e);
				return n;
			},

			remove : function(e) {
				e.parentNode.removeChild(e);
			},

			replace : function(e, n) {
				return e.parentNode.replaceChild(typeof n == 'object' ? n : d.createTextNode(n), e);
			},

			text : function(e) {
				return e ? e.innerText || e.textContent : false;
			},

			walk : function(e, m, f, n, z) {
				if (z = e[f]) do {
					if (_.Node.mask(z, m)) return z;
				} while (z = z[n]);
				return false;
			}

		}, // _.Node

		Load : {

			css : function(h, m) {
				return m ? ( m = m.toLowerCase(), "all" == m && _.log.warn(
					'media="all" is NOT recommended - ' + h
				)) : _.log.warn(
					'no media type declared, defaulting to "screen,projection,tv"'
				), _.make("link", {
					rel : "stylesheet",
					href : h,
					media : m || "screen,projection,tv",
					last : d.head
				}
			)},

			script : function(s, a) {
				(a || (a = {})).src = s;
				a.last = d.body;
				return _.make('script', a);
			}

		}, // _.Load

		Select : {
		}, // _.Select

		Scroll : {

			maxX : function() {
				return d.body.scrollWidth - d.documentElement.clientWidth;
			},

			maxY : function() {
				return d.body.scrollHeight - d.documentElement.clientHeight;
			},

			x : function() {
				return w.scrollX || w.pageXOffset || d.body.scrollLeft;
			},

			y : function() {
				return w.scrollY || w.pageYOffset || d.body.scrollTop;
			}

		}, // _.Scroll

		stringNormalize : function(s, t) {
			s = (
				typeof s == 'undefined' || (!s && s !== 0)
			) ? '' : String(s).trim();
			return t ? s.tolowercase() : s;
		}, // _.stringNormalize

		Throw : {

			isNaN : function(e) {
				_.Throw.isNull(e);
				if (e != e) throw new RangeError('value must be a number');
			},

			isNull : function(e) {
				if (e == null || typeof e == 'undefined') throw new TypeError(
					'Variable Null or Undefined'
				);
			},

			nonElement : function(e) {
				_.Throw.isNull(e);
				if (e.nodeType !== 1) throw new TypeError(e + ' is not a DOM Element');
			},

			nonInstance : function(e, t) {
				_.Throw.isNull(e);
				if (!e instanceof i) throw new TypeError(e + ' is not an instance of ' + i);
			},

			nonTag : function(e, t) {
				_.Throw.isNull(e);
				if (
					1 == !e.nodeType || e.tagName != t.toUpperCase()
				) throw new TypeError(e + ' is not a <' + t + '>');
			},

			nonType : function(e, t) {
				_.Throw.isNull(e);
				if (typeof e !== t) throw new TypeError(e + ' is not type "' + t + '"');
			},

			range : function(v, l, h) {
				_.Throw.isNaN(v);
				if (v == Infinity) throw new RangeError(
					'value must be less than Inifinty'
				);
				if (!isNaN(l) && v < l) throw new RangeError(
					'number must be greater than or equal to ' + l
				);
				if (!isNaN(h) && v > h) throw new RangeError(
					'number must be less than or equal to ', + h
				);
			}

		}, // _.throw

		uSort : {

			element : function(e, c) {
				tList1 = [];
				switch (e.tagName) {
					case 'TBODY' :
						_.Node.eachChild(e, uSortTBODYRow, 'TR');
						break;
					case 'UL':
					case 'OL':
						_.Node.eachChild(e, uSortLi, 'LI');
						break;
					default: throw new TypeError(e + ' is not a TBODY, UL, or OL');
				}
				e.setAttribute(d_sort, true);
				e[d_sort] = true;
				tList1.sort(c);
				_.Node.flush(e);
				for (var i = 0, j; j = tList1[i]; i++) e.appendChild(j.tag);
				tList1 = [];
			},

			restore : function(e) {
				switch (e.tagName) {
					case 'TBODY':
					case 'UL':
					case 'OL':
						if (e[d_sort]) _.uSort.element(e, originalSort);
					break;
					default: throw new TypeError(e + ' is not a TBODY, UL, or OL');
				}
			}

		} // _.uSort

	};

	// polyfills

	ptAdd(Array, {

		callbackAnd : function(e, c) {
			for (var i = 0, l = this.length; i < l; i++)
				if (!c(e, this[i])) return false;
			return true;
		},

		callbackAndAll : function(e, c) {
			for (var i = 0, l = this.length, r = false; i < l; i++)
				r = c(e, this[i]) && r;
			return r;
		},

		callbackOr : function(e, c) {
			for (var i = 0, l = this.length, r = false ; i < l; i++)
				r = c(e, this[i]) || r;
			return r;
		},

		every : function(c, a) {
			_.Throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var i = 0, j = this.length; i < j; i++)
				if (!c.call(a, this[i], i, this)) return false;
			return true;
		},

		fill : function(v, s, e) {
			_.Throw.isNull(this);
			if ('undefined' == typeof s) s = 0;
				else if (s < 0) s += this.length;
			if ('undefined' == typeof e) e = this.length;
			for (var i = s; i < e; i++) this[i] = v;
			return this;
		},

		filter : function(c, a) {
			_.Throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var r = [], i = 0, j = this.length; i < j; i++)
				if (c.call(a, this[i], i, this)) r.push(this[i]);
			return r;
		},

		find : function(c, a) {
			_.Throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var i = 0, j = this.length; i < j; i++)
				if (c.call(a, this[i], i, this)) return this[i];
		},

		findIndex : function(c, a) {
			_.Throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var i = 0, j = this.length; i < j; i++)
				if (c.call(a, this[i], i, this)) return i;
		},

		forEach : function(c, a) {
			_.Throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var i = 0, j = this.length; i < j; i++)
				c.call(a, this[i], i, this);
		},

		includes : function(s, i) {
			_.Throw.isNull(this);
			if (this.length == 0) return false;
			if (typeof i == "undefined" || (i < 0 && (i += this.length) < 0)) i = 0;
			var t = s != s;
			for (var j = this.length; i < j; i++)
				if (s == this[i] || (t && this[i] != this[i])) return true;
			return false;
		},

		indexOf : function(s, i) {
			_.Throw.isNull(this);
			if (this.length == 0) return false;
			if (typeof i == "undefined" || (i < 0 && (i += this.length) < 0)) i = 0;
			for (var j = this.length; i < j; i++) if (this[i] == s) return i;
			return -1;
		},

		isArray : function(a) {
			return Object.prototype.toString.call(a) === '[object Array]';
		},

		lastIndexOf : function(s, i) {
			_.Throw.isNull(this);
			if (this.length == 0) return false;
			if (
				typeof i == "undefined" || (i < 0 && (i += this.length) < 0)
			) i = this.length;
			while (i > 0) if (this[--i] == s) return i;
			return -1;
		},

		map : function(c, a) {
			_.Throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var r = [], i = 0, j = this.length; i < j; i++)
				r.push(c.call(a, this[i], i, this));
			return r;
		},

		reduce : function(c, v) {
			_.Throw.nonType(c, 'function');
			var i = 0, j = this.length;
			if (typeof v == 'undefined') {
				if (!j) throw new TypeError(
					'Reduce of empty array with no initial value'
				);
				if (j == 1) return this[0];
				v = this[i];
				i++;
			}
			while (i < j) v = c(v, this[i], i++, this);
			return v;
		},

		reduceRight : function(c, v) {
			_.Throw.nonType(c, 'function');
			var i = this.length;
			if (typeof v == 'undefined') {
				if (!i) throw new TypeError(
					'Reduce of empty array with no initial value'
				);
				if (i == 1) return this[0];
				v = this[--i];
			}
			while (i > 0) v = c(v, this[--i], i, this);
			return v;
		},

		some : function(c, a) {
			_.Throw.nonType(c, 'function');
			a = typeof a == 'undefined' ? void 0 : a;
			for (var i = 0, j = this.length; i < j; i++)
				if (c.call(a, this[i], i, this)) return true;
			return false;
		}

	});

	// you can't polyfill 'of' from prototype :/

	if (!Array.of) Array.of = function() {
		_.Throw.isNull(this);
		return Array.prototype.slice.call(arguments);
	};

	ptAdd(String, {

		jsToCssName : function() {
			_.Throw.isNull(this);
			var
				v = this.stripCamel(),
				f = this.indexOf('-');
			return ((
				(f > 0) && (f = v.substr(0,f)) &&
				(_.browserPrefixes.indexOf(f) !== -1)
			) ? '-' : '') + this;
		},

		pad : function(len, ch, i) {
			_.Throw.isNaN(len);
			if ((i = Math.abs(len) - this.length) <= 0) return this;
			ch = (!ch && ch !== 0) ? ' ' : String(ch).charAt(0);
			return len < 0 ? ch.repeat(i) + this : this + ch.repeat(i);
		},

		repeat : function(c) {
			_.Throw.isNull(this);
			_.Throw.range(c = c || 0, 0, Math.floor(0x10000000 / this.length));
			return Array(Math.floor(c) + 1).join(this);
		},

		splitSelector : function() {
			_.Throw.isNull(this);
			var
				r = { tag : 'div', id : false, classes : false},
				s = this, t;
			if ((t = s.indexOf('.')) >= 0) {
				r.classes = s.substr(t + 1).replace('.', ' ');
				s = (t > 0) ? s.substr(0, t) : '';
			}
			if ((t = s.indexOf('#')) >= 0) {
				r.id = s.substr(t + 1);
				s = (t > 0) ? s.substr(0, t) : '';
			}
			if (s.length > 0) r.tag = s;
			return r;
		},

		strFrom : function(c, l) {
			return (l = l ? this.lastIndexOf(c) : this.indexOf(c)) == -1 ? false : this.substr(l + 1);
		},

		stripCamel : function(l) {
			if (typeof l == 'undefined') l = '-';
			return _.Throw.isNull(this), this.replace(stripCamelRegex, function(m) {
				return l + m.toLowerCase();
			});
		},

		toCamel : function(l) {
			if (typeof l == 'undefined') l = '-';
			return _.Throw.isNull(this), this.replace(toCamelRegex, function(m, m2, i) {
				return (i === 0 ? m : m.toUpperCase()).replace(l, '');
			});
		},

		trim : function() {
			return _.Throw.isNull(this), this.replace(trimRegex, '');
		}

	});

	if (!w.addEventListener) {
		EventIE = function(e, v, c) {
			e.attachEvent('on' + v, function(n) {
				n || (n = w.event);
				n.target || (n.target = n.srcElement);
				n.currentTarget || (n.currentTarget = e);
				c(n);
			});
		};
		_.Event.add = function(e, v, c) { new EventIE(e, v, c); };
	}

	if (d.selection) {
		_.Select.node = function(e, r) {
			r = d.body.createTextRange();
			r.moveToElementText(e);
			r.select();
			return true;
		};
		_.Select.none = function() {
			d.selection.empty();
			return true;
		};
	} else if (w.getSelection) {
		_.Select.node = function(e, r, s) {
			s = w.getSelection();
			r = d.createRange();
			r.selectNodeContents(e);
			s.removeAllRanges();
			s.addRange(r);
			return true;
		};
		_.Select.none = function() {
			w.getSelection().removeAllRanges();
			return true;
		};
	} else {
		_.Select.node =
		_.Node.addSelectButton = function() {
			return jsWarn('selection of content');
		};
		_.Select.none = function() {
			return jsWarn('de-selection of content');
		};
	}

	if (
		w.clipboardData &&
		w.clipboardData.setData
	) _.Select.toClipboard = function() {
		w.clipboardData.setData('Text', (
			typeof d.getSelection === 'function' ?
			String(d.getSelection()) :
			d.selection.createRange().text
		));
		return true;
	}; else if (
		d.queryCommandSupported('copy')
	) _.Select.toClipboard = function() {
		d.execCommand('copy');
		return true;
	}; else _.Select.toClipboard = function() {
		return jsWarn('copy to clipboard');
	};

	if (typeof d.querySelectorAll == 'function') {
		_.Query = function(e, q) { return e.querySelector(q); };
		_.Query.all = function(e, q) {
			return [].slice.call(e.querySelectorAll(q));
		};
	} else {
		var y = d.createStyleSheet();
		_.Query = function(e, s, r) {
			r = _.Query.all(e, s, 1);
			return (r && r.length > 0) ? r[0] : null;
		};
		_.Query.all = function(t, s, l, r) {
			l = l || 32767;
			r = [];
			y.addRule(s, 'fu:bar');
			function p(e) {
				if ((l > 0) && (e.currentStyle.fu === 'bar')) r.push(e);
				return --l > 0;
			}
			_.Node.eachAll(t, p);
			y.removeRule();
			return r;
		};
	}

	w.JSON || (w.JSON = {
		parse : function(s) { return eval('(' + s + ')'); },
		stringify : function(s, r) {
			if (null == s) return s;
			switch (typeof s) {
				case 'number': return isFinite(s) ? s.toString() : 'null';
				case 'boolean': return s.toString();
				case 'object':
					if (typeof s.toJSON === 'function') return JSON.stringify(s.toJSON());
					r = [];
					if (Array.prototype.isArray.call(s)) {
						s.forEach(function(e) { r.push(JSON.stringify(e)); });
						return '[' + r.join() + ']';
					}
					if (_.toString(s) === '[object Object]') {
						for (var i in s) r.push(JSON.stringify(i) + ':' + JSON.stringify(s[i]));
						return '{' + r.join() + '}';
					}
			}
			return '"' + s.toString().replace(escRegex, escFunc) + '"';
		}
	});

	/*
		performance and requestAnimation Polyfill based on code
		by Erik Möller. I'd link but the bloody page is gone!
		Thanks "My Opera"
	*/

	var p =
		(false == 'performance' in w) ?
		(w.performance = {}) :
		w.performance;
	if (false == 'now' in p) {
		var nowOffset = (
			p.timing && p.timing.navigationStart
		) ? p.timing.navigationStart : new Date().getTime();
		p.now = function() { return new Date().getTime() - nowOffset; };
	}

	if (!browserFix(w, raf)) w[raf] = function(c) {
		var
			n = p.now(),
			m = Math.max(0, 16.666667 - n - lastAnimTime);
		lastAnimTime = n + m;
		return setTimeout( function() { c(lastAnimTime); }, m);
	};

	if (
		!browserFix(w, caf) &&
		!browserFix(w, caf, 'CancelRequestAnimationFrame')
	) w[caf] = clearTimeout;
	
	d.head || (d.head = d.getElementsByTagName('head')[0]);
	
	_.Class.add(d.body, 'elementals');

})(window, document);